'#Reference {A518A78A-ECF7-4AD8-AFF1-A7482FEA9A0F}#1.0#0#C:\Winfilm\Index1.exe#FtgIndex1
'#Reference {101F9C56-A0F3-455C-ABBB-191168ABCF94}#1.0#0#C:\Program Files\Chilkat Software Inc\Chilkat XML\ChilkatXml.dll#Chilkat XML 5.0.0
'Program SproMonitorReport for FilmStar MONITOR
'         Copyright FTG Software 2005
'  Exports monitor data to SYRUSpro XML files
'
' *********************************************
'   Uses ChilkatXML www.chilkatsoft.com (free)
'    Direct link to ChilkatXML installer:
'  www.chilkatsoft.com/download/XmlActiveX.msi
'
'    XML Schema LeyboldMonitoringReport.xsd
' *********************************************
'                
'         MAKE SURE THIS PATH EXISTS
Const SproPath$ = "c:\Winfilm\Leybold XML"
' *********************************************

' Vers 1.01  10/06/05... Use Chip Pos column for chip number

Option Explicit
DefInt i-N
DefSng A-H, O-Z
Option Base 1

Dim fsIndex As FtgIndex1.clsBasic
Dim file$, matl$, range!(), nkVals!(), coeff!()
Dim ntyp$, ktyp$
Dim xml0 As ChilkatXml

Sub Main
    Dim i, md$, f$
    Set fsIndex = New FtgIndex1.clsBasic
    Set xml0 = New ChilkatXml
    With xml0
        .Tag = "monitoringreport"
        .AddAttribute "name", "FilmStar Dispersion Test"
        .AddAttribute "program", "FilmStar MONITOR"
        .AddAttribute "version", "1.01"
        .AddAttribute "date", CStr(Now)
        .AddAttribute "uuid", UUID
        .AddAttribute "xmlns:xsi", "http://www.w3.org/2001/XMLSchema-instance"
        .AddAttribute "xsi:noNamespaceSchemaLocation", "LeyboldMonitoringReport.xsd"

        With .FindOrAddNewChild("dispersionsdata")
            file$ = SubstrateFile()
            GetIndices
            AddDispersion .NewChild("dispersion", ""), "Substrate"
            For i = 1 To NumFilmMatls
                file$ = FilmMatlFile(i)
                GetIndices
                AddDispersion .NewChild("dispersion", ""), "Layer"
            Next i
        End With

        With .FindOrAddNewChild("design")
            With .NewChild("match_angle", "0.0")
                .AddAttribute "unit", "deg"
            End With
        End With

        Select Case OpticalMode
        Case 1
            md$ = "Reflectance_Single_Side"
        Case 2
            md$ = "Transmittance"
        Case 3
            md$ = "Reflectance"
        Case 4
            md$ = "Retro_Reflectance"
        End Select

        With .FindOrAddNewChild("plant")
            With .NewChild("measurement", "")
                .AddAttribute "mode", md$
            End With
        End With

        With .FindOrAddNewChild("monitoringspreadsheet")
            For i=1 To NumLayers
                With .NewChild("layer", "")
                    .AddAttribute "number", CStr(i)
                    .AddAttribute "material", WsGetText(i, 4)  ' Layer Set
                    .AddAttribute "wavelength", Format$(WsGetNum(i, 5),"0")  ' Wavelength
                    .AddAttribute "physical_thickness", CStr$(WsGetNum(i,12) * WsGetNum(i, 5)/ (4 * WsGetNum(i, 13)))
                    .AddAttribute "optical_thickness", CStr$(WsGetNum(i, 12))
                    .AddAttribute "refractive_index", CStr$(WsGetNum(i, 13))
                    .AddAttribute "chip", CStr$(WsGetNum(i, 9) Mod 100)	 ' Chip Pos
                End With
            Next i
        End With

        f$ = GetFilePath$(,"xml", SproPath, "Save SYRUSpro Monitoring Report", 3)  ' Save file
        If f$ <> "" Then
            .SaveXml f$
            MsgBox "File " & f$ & " saved successfully", vbOkOnly, "Optical Thin Film Exchange"
        End If

    End With
End Sub

Sub AddDispersion(xml As ChilkatXml, ByVal typ$)
    Dim i, nco
    With xml
        .AddAttribute "name", file$
        .AddAttribute "material", matl$
        .AddAttribute "type", typ$
        With .FindOrAddNewChild("range")
            .AddAttribute "min", CStr$(range(1))
            .AddAttribute "max", CStr$(range(2))
        End With
        If ntyp$ = "NKTable" Then
            With .FindOrAddNewChild("complex_refractive_index_table")
                For i=1 To UBound(nkVals, 1)
                    With .NewChild("row", "")
                        .AddAttribute "wavelength", CStr$(nkVals(i, 1))
                        .AddAttribute "n", CStr$(nkVals(i, 2))
                        .AddAttribute "k", CStr$(nkVals(i, 3))
                    End With
                Next i
            End With
        Else
            With .FindOrAddNewChild("refractive_index")
                If ntyp$ = "Table" Then
                    nco = 0
                    .AddAttribute("method", "Table")
                    For i=1 To UBound(nkVals, 1)
                        With .NewChild("row", "")
                            .AddAttribute "wavelength", CStr$(nkVals(i, 1))
                            .AddAttribute "n", CStr$(nkVals(i, 2))
                        End With
                    Next i
                Else
                    nco = UBound(coeff)
                    Select Case ntyp$
                    Case "Sell1"
                        .AddAttribute("method", "Sellmeier1")
                        With .FindOrAddNewChild("coefficientsNSellmeier1")
                            For i = 1 To nco
                                .AddAttribute "a" & CStr$(i-1), CStr$(coeff(i))
                            Next i
                        End With
                    Case "Sell2"
                        .AddAttribute("method", "Sellmeier2")
                        With .FindOrAddNewChild("coefficientsNSellmeier2")
                            For i = 1 To nco
                                .AddAttribute "a" & CStr$(i-1), CStr$(coeff(i))
                            Next i
                        End With
                    Case "Sell2'"
                        .AddAttribute("method", "Sellmeier2TickMark")
                        With .FindOrAddNewChild("coefficientsNSellmeier2TickMark")
                            For i = 1 To nco
                                .AddAttribute "a" & CStr$(i-1), CStr$(coeff(i))
                            Next i
                        End With
                    Case "Sell3"
                        .AddAttribute("method", "Sellmeier3")
                        With .FindOrAddNewChild("coefficientsNSellmeier3")
                            For i = 1 To nco
                                .AddAttribute "a" & CStr$(i-1), CStr$(coeff(i))
                            Next i
                        End With
                    Case "Cauchy"
                        .AddAttribute("method", "Cauchy")
                        With .FindOrAddNewChild("coefficientsNCauchy")
                            For i = 1 To nco
                                .AddAttribute "a" & CStr$(i-1), CStr$(coeff(i))
                            Next i
                        End With
                    Case "Hart1"
                        .AddAttribute("method", "Hartmann1")
                        With .FindOrAddNewChild("coefficientsNHartmann1")
                            For i = 1 To nco
                                .AddAttribute "a" & CStr$(i-1), CStr$(coeff(i))
                            Next i
                        End With
                    Case "Hart2"
                        .AddAttribute("method", "Hartmann2")
                        With .FindOrAddNewChild("coefficientsNHartmann2")
                            For i = 1 To nco
                                .AddAttribute "a" & CStr$(i-1), CStr$(coeff(i))
                            Next i
                        End With
                    End Select
                End If
            End With
        End If
        If ntyp$ <> "NKTable" Then
            With .FindOrAddNewChild("extinction_coefficient")
                Select Case ktyp$
                Case "Zero", ""
                    .AddAttribute("method", "Zero")
                Case "Table"
                    .AddAttribute("method", "Table")
                    For i=1 To UBound(nkVals, 1)
                        With .NewChild("row", "")
                            .AddAttribute "wavelength", CStr$(nkVals(i, 1))
                            .AddAttribute "k", CStr$(nkVals(i, 3))
                        End With
                    Next i
                Case "Sell"
                    .AddAttribute("method", "Sellmeier")
                    With .FindOrAddNewChild("coefficientsKSellmeier")
                        For i = 1 To UBound(coeff)
                            .AddAttribute "b" & CStr$(i-1), CStr$(coeff(i + nco))
                        Next i
                    End With
                Case "Exp"
                    .AddAttribute("method", "Exponential")
                    With .FindOrAddNewChild("coefficientsKExponential")
                        For i = 1 To UBound(coeff)
                            .AddAttribute "b" & CStr$(i-1), CStr$(coeff(i + nco))
                        Next i
                    End With
                End Select
            End With
        End If
    End With
End Sub

Sub GetIndices()
    Const t$ = "Open Index File"
    Dim i, k1, k2, m, code$, s$
    If fsIndex.FileOpen(file$) Then
        code$ = fsIndex.FunctionCode
        Debug.Print file$ & " - " & code$   ' useful for debugging
        k1 = InStr(code$,"SPRO:")
        If k1 = 0 Then
            MsgBox "Invalid SYRUSpro code", vbCritical, t$
            End
        End If
        k2 = InStr(code$, "|")
        If k2 = 0 Then
            MsgBox "Invalid SYRUSpro code", vbCritical, t$
            End
        Else
            matl$ = Mid$(code$, k2 + 1)
            If matl$="" Then
                MsgBox "Invalid SYRUSpro code", vbCritical, t$
                End
            Else
                Mid$(code$, k2) = ""
            End If
        End If

        code$ = Mid$(code$, k1 + 5)
        k1 = InStr(code$, ",")
        If k1 = 0 Then
            ntyp$ = Mid$(code$, 1, InStr(code$, "|") - 1)
            ktyp$ = ""
        Else
            ntyp$ = Mid$(code$, 1, k1 - 1)
        End If
        If ntyp$ = "NKTable" Then
            nkVals = fsIndex.nkTable
        Else
            Select Case ntyp$
            Case "Table"
                nkVals = fsIndex.nkTable
            Case "Sell1", "Sell2", "Sell2'", "Sell3", "Cauchy", "Hart1", "Hart2"
                coeff = fsIndex.FunctionCoeff
            Case Else
                MsgBox "Undefined SYRUSpro code for index n", vbCritical, t$
                End
            End Select

            Select Case ktyp$
            Case "Zero", ""
            Case "Table"
                nkVals = fsIndex.nkTable
            Case "Sell", "Exp"
                coeff = fsIndex.FunctionCoeff
            Case Else
                MsgBox "Undefined SYRUSpro code for index k", vbCritical, t$
                End
            End Select
        End If
        range = fsIndex.FunctionRange
    Else
        MsgBox "Cannot open " & file$, vbCritical, t$
        End
    End If
End Sub

