'#Reference {5B50E6F7-C8A1-46D4-955E-B6115F85A311}#1.0#0#C:\Program Files\filemaker_8\FileMaker Pro 8 Advanced\FileMaker Pro Advanced.exe#FileMaker Pro 7.0 Type Library
' SaveSpectrum.bas for FilmStar MEASURE/Scantraq (DESIGN)
' Copyright 2003-2005 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' Sample program showing FilmStar-FileMaker 8 interface
' FileMaker Pro database 'Spectra.fp7'

' 06.02.04...FM7 version
' 03.19.05...Move FileMaker check to ModFMCHeck.bas
' 10.09.05...FM8 version

' NOTE: If program fails to run, it may be necessary
'       to re-establish a reference to the FileMaker
'       Pro 7.0 Type Library (Edit...References)

'#Uses "FM_RunCheck.bas"

Option Explicit
DefLng i-N
DefSng a-H, O-Z

' ************* Change path as required ************

' Note: If pic$ is changed, the change must be
'       implemented in FM script 'InsertPic'
Const pic$ = "c:\Winfilm\Course2\Database\temp.png"

' Note: If temp$ is changed, the change must be
'       implemented in field labeled Temp File
Const temp$ = "c:\Winfilm\Course2\Database\temp.dx"

' Database name to ensure correct file is opened
Const dBase$ = "spectra.fp7"

' *************************************************

Public FMApp As FMPRO70Lib.Application
Public FMDocs As FMPRO70Lib.Documents
Public dbFile As FMPRO70Lib.Document

Const Title$ = "Save Spectrum"
Const Delay = .5    ' delay in seconds to avoid overrunning FileMaker

Sub Main
    GraphSetup
    FMRun       
End Sub

Sub FMRun
    On Error GoTo MainErr
    If Not FMCheck(Title$) Then End
    Set FMApp = New FMPRO70Lib.Application
    DoEvents
    If FMApp.Visible = 0 Then
        FMApp.Quit ' remove process
        DoEvents
        Set FMApp = Nothing
        MsgBox "FileMaker Pro is not visible" , vbOkOnly + vbCritical, Title$
        End
    End If
    Set FMDocs = FMApp.Documents
    If FMDocs.Count > 0 Then
        Set dbFile = FMDocs.Active
        If InStr(LCase(dbFile.FullName), LCase(dBase$)) = 0 Then
            MsgBox "Active database must be " & dBase$, vbOkOnly + vbCritical, Title$
        Else
            DoFMTasks
        End If
    Else
        MsgBox "Database " & dBase$ & " is not open", vbOkOnly + vbCritical, Title$
    End If
MainExit:
    Set FMDocs = Nothing
    Set dbFile = Nothing
    Set FMApp = Nothing
    Busy False  ' just in case hourglass left
    Exit Sub
MainErr:
    MsgBox Err.Description, vbOkOnly + vbCritical, Title$
    GoTo MainExit
End Sub

Sub DoFMTasks
    DoCIECalc
    DoEvents
    dbFile.DoFMScript "Get Spectrum"   ' transfers temp$ to FM
End Sub

Sub DoCIECalc
    Dim  x, y, yy
    Const c$ = ", "
    PlotClose
' *******************************
'  scan        ' MEASURE/Scantraq
    If DataPoints = 0 Then   Calculate   ' DESIGN
' *******************************
    FileSave temp$
    DoEvents
    PlotActivate
    PlotNext
    DoEvents
    If MsgBox("Does the spectrum look correct?", vbYesNo + vbQuestion, "FilmStar -> FM Pro") = vbNo Then
       Set FMDocs = Nothing
       Set dbFile = Nothing
       PlotClose
       End
    End If
    PlotSave pic$
    DoEvents
    dbFile.DoFMScript "InsertPic"   ' creates new record
    DoEvents
    Wait Delay   ' if this is looped too fast, FileMaker can't keep up

    SetIlluminant 2  ' Illuminant A
    GetCie x, y, yy
    Clipboard Format$(x, "0.0000") & c$ & Format$(y,"0.0000") & c$ & Format$(yy, "0.000")
    DoEvents
    dbFile.DoFMScript "InsertCIE_A"
    Wait Delay

    SetIlluminant 5  ' Illuminant D65
    GetCie x, y, yy
    Clipboard Format$(x, "0.0000") & c$ & Format$(y,"0.0000") & c$ & Format$(yy, "0.000")
    DoEvents
    dbFile.DoFMScript "InsertCIE_D65"
    Wait Delay
    PlotClose
End Sub

Sub GraphSetup
  ' FSPlot setup code for FilmStar BASIC:
    PlotConfig 8741961, 102129, 0
    PlotSize 6480, 5430, 107
    PlotTitleFont = "Arial"
    PlotTitleSize = 110
    PlotLegendSize = 100
    PlotAxesFont = "Arial"
    PlotAxesLabelSize = 110
    PlotAxesNumberSize = 110
    PlotFontFixed = False
    PlotFontFixedSize = 2
    PlotAxesConfig = 6
    PlotEdgeSpace 75, -20, 45, 45
    PlotAxesSpace .15, .25, .5, 1.5
    PlotBitmapMode = False
End Sub

